#include<p16f84a.inc>
;CONFIG	_XT_OSC & _WDT_OFF & _PWRTE_ON
;  HT1611  Pic16 + Led
;
;TOCHKA	 115
;
DIG1	EQU	H'0C'	;   "1"
DIG2	EQU	H'0D'	;   "2"
DIG3	EQU	H'0E'	;   "3"
DIG4	EQU	H'0F'	;   "4"
DIG5	EQU	H'10'	;   "5"
DIG6	EQU	H'11'	;   "6"
DIG7	EQU	H'12'	;   "7"
DIG8	EQU	H'13'	;   "8"
DIG9	EQU	H'14'	;   "9"
TOCH	EQU H'15'	; 
LED1	EQU	H'16'	;   1
LED2	EQU	H'17'	;   2
LED3	EQU	H'18'	;   3
LED4	EQU	H'19'	;   4
LED5	EQU	H'1A'	;   5
LED6	EQU	H'1B'	;   6
LED7	EQU	H'1C'	;   7
LED8	EQU	H'1D'	;   8
LED9	EQU	H'1E'	;   9
R3		EQU	H'1F'	;   

MUT		EQU	H'4A'	;    
LPOZ	EQU	H'47'	;    
DPOZ	EQU	H'46'	;    
CBI		EQU	H'45'	;  
CBY		EQU	H'44'	;  
COU		EQU	H'43'	;  
R2		EQU	H'42'	;  ( )
R1		EQU	H'41'	;  (   )
LOUT	EQU	H'40'	;    

VOL		EQU	H'4F'	;   
BAL		EQU	H'4E'	;   
BAS		EQU	H'4D'	;   
TRE		EQU	H'4C'	;   
TCONS	EQU	H'4B'	; 

FUR		EQU	H'49'	;:  \  \  \  \*\*\*\*\
FSER	EQU	H'48'	;: *\ MUTE\ CHANGE\   
					;\TIME OUT \  \ _\ 4/8BIT
;*************************************************************************
;*************************************************************************
		ORG H'0'
RESET	GOTO	START
		NOP
		NOP
		NOP
		ORG H'4'
;Interrupt  
		BCF		INTCON,GIE	;  
		BCF		PORTA,H'1'	;  IRQ
		MOVF	TCONS,W		;    (>30h)
		MOVWF	R1			;  
		COMF	R1			;
		MOVF	R1,W		;
		MOVWF	TMR0		;  
		BTFSC	INTCON,INTF	;     
		GOTO	CLKI		;   
		BTFSC	INTCON,T0IF	;    
		GOTO	TOF			;   
		GOTO	EXIT		;  
START
;************************************
;    *
;************************************
		BCF		STATUS,IRP
		BCF		STATUS,RP1
		CALL	READTAB		;  
		CALL	READCON		; 
		CLRF	LPOZ		;   
		MOVF	TCONS,W		; 
		MOVWF	COU			; 
		BSF		STATUS,RP0	;  1
		MOVLW	B'00010001'	;A0, A4 -  ; A1, A2, A3 - 
		MOVWF	TRISA
		MOVLW	B'11111111'	; -  ; B0...B7
		MOVWF	TRISB
		MOVLW	B'11010000'	; ,    
		MOVWF	OPTION_REG	; ,     
							;     
		MOVLW	B'10110000'	;     
		MOVWF	INTCON		;,   
		BCF		STATUS,RP0	;  0
		BSF		PORTA,H'1'	;  IRQ
LOOP
;*****************************
;*     *
;*****************************
		MOVF	TOCH,W		;  
		ANDLW	H'F0'		; 
		BTFSS	STATUS,Z
		BSF		FSER,H'4'	;   
		BTFSC	FSER,H'4'	;  
		GOTO	SERVICE		;   
		BTFSS	FSER,H'2'	;   
		GOTO	LOOP		;   
		CALL	VBUF		;   
		GOTO	ECASE		;  
SERVICE
;*****************
;*   *
;*****************
;1
		MOVF	TOCH,W
		SUBLW	B'01000000'
		BTFSC	STATUS,Z
		CALL	VOLP		; +
;2
		MOVF	TOCH,W
		SUBLW	B'01000001'
		BTFSC	STATUS,Z
		CALL	VOLM		; -
;3
		MOVF	TOCH,W
		SUBLW	B'01000010'
		BTFSC	STATUS,Z
		CALL	BALP		; +
;4
		MOVF	TOCH,W
		SUBLW	B'01000011'
		BTFSC	STATUS,Z
		CALL	BALM		; -
;5
		MOVF	TOCH,W
		SUBLW	B'01000100'
		BTFSC	STATUS,Z
		CALL	BASP		; +
;6
		MOVF	TOCH,W
		SUBLW	B'01000101'
		BTFSC	STATUS,Z
		CALL	BASM		; -
;7
		MOVF	TOCH,W
		SUBLW	B'01000110'
		BTFSC	STATUS,Z
		CALL	TREP		; +
;8
		MOVF	TOCH,W
		SUBLW	B'01000111'
		BTFSC	STATUS,Z
		CALL	TREM		; -
;9
		MOVF	TOCH,W
		SUBLW	B'01001000'
		BTFSC	STATUS,Z
		CALL	WTCONS		;   TIMEOUT 
;10
		MOVF	TOCH,W
		SUBLW	B'01001001'
		BTFSC	STATUS,Z
		CALL	WSIM		; 
;11
		MOVF	TOCH,W
		SUBLW	B'01001010'
		BTFSC	STATUS,Z
		CALL	VBUF		; 
;12
		MOVF	TOCH,W
		SUBLW	B'01001011'	;FSER, CHANGE SET
		BTFSC	STATUS,Z
		BSF		FSER,H'5'	;    
;13
		MOVF	TOCH,W
		SUBLW	B'01001100'	;FSER, CHANGE CLEAR
		BTFSC	STATUS,Z
		BCF		FSER,H'5'	;    
;14
		MOVF	TOCH,W		; () 
		SUBLW	B'01001101'	;(   EEPROM)
		BTFSC	STATUS,Z
		GOTO	RESET		; () 
;15
		MOVF	TOCH,W		; 
		SUBLW	B'01001110'	;(    EEPROM
		BTFSC	STATUS,Z	;  FSER, CHANGE SET)
		CALL	POFF		; 
;16
		MOVF	TOCH,W		;
		SUBLW	B'01001111'	;
		BTFSC	STATUS,Z	;
		CALL	MUTE		;   
ECASE
		BCF		FSER,B'00000100'	;   
		BCF		FSER,B'00010000'	;  
		GOTO	LOOP		;
		RETURN				;   
EXIT	BCF		INTCON,T0IF	;   
		BCF		INTCON,INTF	;    
		BSF		INTCON,GIE	;  
		BSF		PORTA,H'1'	;  IRQ
		RETFIE				;  
;*************************************
;*************************************
;   (TimeOut)******
;*************************************
;*************************************
TOF
		BSF		STATUS,RP0	;  1
		MOVLW	B'00000000'	; -  B0...B7
		MOVWF	TRISB		; 
		BCF		STATUS,RP0	;  0
;****************************************
;*       *
;****************************************
VOLREG	MOVF	LPOZ,W		; 
		IORWF	FUR,W		;  
		MOVWF	PORTB		;  
		BSF		PORTA,H'3'	;  22
		BCF		PORTA,H'3'	; 
OUTLED	MOVF	TCONS,W		;  
		SUBWF	COU,W		;   
		BTFSS	STATUS,Z	;  
		GOTO	EREG		;   - 
		MOVF	LOUT,W		; 
		MOVWF	PORTB		;  
		BSF		PORTA,H'2'	;  22
		INCF	LPOZ		;
		BCF		PORTA,H'2'	; 
;******************************
;*   " " *
;******************************
EREG	MOVF	LPOZ,W		;    LED
		SUBLW	H'0A'		;     + 1
		BTFSC	STATUS,Z	;  
		CLRF	LPOZ		; 
;****************************************
;*     *
;****************************************
		MOVF	VOL,W		;  
		SUBWF	COU,W		;   
		BTFSC	STATUS,Z	;  
		BCF		FUR,H'7'		;  -   
		MOVF	BAL,W		;  
		SUBWF	COU,W		;   
		BTFSC	STATUS,Z	;  
		BCF		FUR,H'6'		;  -   
		MOVF	BAL,W		;  
		SUBWF	COU,W		;   
		BTFSC	STATUS,Z	;  
		BCF		FUR,H'5'		;  -   
		MOVF	BAL,W		;  
		SUBWF	COU,W		;   
		BTFSC	STATUS,Z	;  
		BCF		FUR,H'4'		;  -   
		DECF	COU			;   1
		MOVF	COU,W
		SUBLW	H'0'
		BTFSS	STATUS,Z
		GOTO	NECST
		MOVLW	B'11110000'	;   1
		IORWF	FUR
		MOVF	TCONS,W
		MOVWF	COU
NECST
		BSF		STATUS,RP0	;  1
		MOVLW	B'11111111'	; -  B0...B7
		MOVWF	TRISB		; 
		BCF		STATUS,RP0	;  0
		GOTO	EXIT		;  
;*************************************
;*************************************
;   INT0 (CLK)*******
;*************************************
;*************************************
CLKI
		BTFSS	PORTA,H'4'	;  
		GOTO	B4			;   1   (4BIT)
B8		BSF		FSER,H'0'		; "0"  8  () .
		GOTO	BOUT		;  (1 - 8BIT)
B4		BCF		FSER,H'0'		; "1"  4 
BOUT	BTFSC	PORTA,H'0'	;   
		GOTO	ONE			; "1"    
		BCF		R3,H'0'		; "0"    0
		GOTO	NULL		;  
ONE		BSF		R3,H'0'		;  0
NULL	RLF		R3			; 
		INCF	CBI			;  
		BTFSC	FSER,H'0'	;   
		GOTO	BIT8		; "1"  8 
BIT4	MOVLW	H'4'		;
		GOTO	BITX		;4 
BIT8	MOVLW	H'8'		;  
BITX	SUBLW	CBI			;   
		BTFSS	STATUS,Z	;  (  )
		GOTO	ETOF		;  
BYTECOM	BSF		FSER,H'1'	;  BYTE COMPLEET
		MOVF	CBY,W		;   
		ADDLW	H'0C'		;   
		MOVWF	FSR			;    
		MOVF	R3,W		;  
		MOVWF	INDF		;   
		CLRF	R3			;  
		CLRF	CBI			;  
		INCF	CBY			;    
		MOVLW	H'A'		;   
		SUBLW	CBY			;   
		BTFSC	STATUS,Z	; 
		GOTO	ETOF		;
		BSF		FSER,H'2'	;  " "
		CLRF	CBY			;  
;   
ETOF	GOTO	EXIT		;  
;*************************************
;*************************************
;*************************************
; ************************
;*************************************
;*************************************
;*************************************
VOLP:	MOVF	VOL,W		; 
		SUBWF	TCONS,W		;  
		BTFSS	STATUS,Z	;    ( )
		INCF	VOL			; VOL
		GOTO	CCOM		;
VOLM:	MOVF	VOL,W		; 
		SUBLW	H'0'		;  
		BTFSS	STATUS,Z	;    ( )
		DECF	VOL			; VOL
		GOTO	CCOM		;
BALP:	MOVF	BAL,W		; 
		SUBWF	TCONS,W		;  
		BTFSS	STATUS,Z	;    ( )
		INCF	VOL			; VOL
		GOTO	CCOM		;
BALM:	MOVF	BAL,W		; 
		SUBLW	H'0'		;  
		BTFSS	STATUS,Z	;    ( )
		DECF	BAL			; VOL
		GOTO	CCOM		;
BASP:	MOVF	BAS,W		; 
		SUBWF	TCONS,W		;  
		BTFSS	STATUS,Z	;    ( )
		INCF	BAL			; VOL
		GOTO	CCOM		;
BASM:	MOVF	BAS,W		; 
		SUBLW	H'0'		;  
		BTFSS	STATUS,Z	;    ( )
		DECF	BAS			; VOL
		GOTO	CCOM		;
TREP:	MOVF	TRE,W		; 
		SUBWF	TCONS,W		;  
		BTFSS	STATUS,Z	;    ( )
		INCF	TRE			; VOL
		GOTO	CCOM		;
TREM:	MOVF	TRE,W		; 
		SUBLW	H'0'		;  
		BTFSS	STATUS,Z	;    ( )
		DECF	TRE			; VOL
		GOTO	CCOM		;
WTCONS:	MOVF	DIG1,W		; 
		MOVWF	TCONS			;  
		GOTO	CCOM		;
WSIM:	MOVF	DIG2,W		;  
		SUBLW	H'1F'		;
		BTFSS	STATUS,C	;
		GOTO	EWSIM		;
		MOVF	DIG2,W		;  
		ADDLW	H'20'		;    
		MOVWF	FSR			;    
		MOVF	DIG1,W		;   
		MOVWF	INDF		;  
EWSIM	GOTO	CCOM		;
;*******************************************************
;       **
;*******************************************************
VBUF:			; 
;***************************************************
;*         *
;***************************************************
		CLRF	DPOZ		;
PLOOP
		MOVF	DPOZ,W		;  
		SUBLW	H'09'
		BTFSC	STATUS,Z	;   
		GOTO	EPL			;  
		MOVF	DPOZ,W		;  
		ADDLW	H'0C'		;    
		MOVWF	FSR			;    
		MOVF	INDF,W		;  
		ADDLW	H'20'		;    
		MOVWF	FSR			;    
		MOVF	INDF,W		;  
		MOVWF	R2			;  
		MOVF	TOCH,W		;  
		SUBWF	DPOZ,W		; - -
		BTFSS	STATUS,Z
		GOTO	PL1
		MOVF	R2,W		;   
		IORLW	B'10000000'	;  
		MOVWF	R2			;  
PL1
		MOVF	DPOZ,W		;  
		ADDLW	H'16'		;    
		MOVWF	FSR			;    
		MOVF	R2,W		;  
		MOVWF	INDF		;   
		INCF	DPOZ
		GOTO	PLOOP
EPL
		GOTO	CCOM		;
POFF:			; 
;***************************************
;    **
;***************************************
		BTFSS	FSER,5		;  CHANGE
		GOTO	CCOM		;
		CALL	SAVETAB		; 
		CALL	SAVECON		; 
		CLRF	TOCH		; 
		BCF		FSER,5		;  CHANGE
		RETURN				;
;*********************************
;    **
;*********************************
MUTE:
		BTFSS	FSER,6		;   
		GOTO	VON
VOFF	MOVF	VOL,W
		MOVWF	MUT			; VOL
		CLRF	VOL			; VOL
		BSF		FSER,6		;  MUTE
VON		MOVF	MUT,W
		MOVWF	VOL
		BCF		FSER,6		;  MUTE
		RETURN				;   
CCOM
		CLRF	TOCH		; 
		BSF		FSER,5		;  CHANGE (-)
;  FLASH  
		RETURN				;
;**************************************************
;   EEPROM    **
;**************************************************
READTAB:
		BCF		INTCON,GIE	; 
		CLRF	EEADR		;   EEPROM
		MOVLW	H'20'		;    
		MOVWF	FSR			;   FSR
RDT0
		BSF		STATUS,RP0	;  1
		BSF		EECON1,RD	;  EEDATA
		BCF		STATUS,RP0	;  0
		MOVF	EEDATA,W	;  EEPROM
		MOVWF	INDF		;  
		INCF	FSR
		INCF	EEADR		;   
		MOVF	EEADR,W
		SUBLW	H'20'		;  
		BTFSS	STATUS,Z
		GOTO	RDT0		;  
		BSF		INTCON,GIE	; 
		RETURN
;************************************************************
;   EEPROM      **
;************************************************************
READCON:
		BCF		INTCON,GIE	; 
		MOVLW	H'20'		;
		MOVWF	EEADR		;   EEPROM
		MOVLW	H'4B'		;    
		MOVWF	FSR			;   FSR
RDC0
		BSF		STATUS,RP0	;  1
		BSF		EECON1,RD	;  EEDATA
		BCF		STATUS,RP0	;  0
		MOVF	EEDATA,W	;  EEPROM
		MOVWF	INDF		;  
		INCF	FSR
		INCF	EEADR		;   
		MOVF	EEADR,W
		SUBLW	H'25'		;  
		BTFSS	STATUS,Z
		GOTO	RDC0		;  
		BSF		INTCON,GIE	; 
		RETURN
;*************************************************
;   EEPROM    **
;*************************************************
SAVETAB:		;  EEPROM  
		BCF		INTCON,GIE	; 
		CLRF	EEADR		;   EEPROM
		MOVLW	H'20'		;    
		MOVWF	FSR			;   FSR
SVT0
		MOVF	INDF,W		; 
		MOVWF	EEDATA		;  EEDATA
		CALL	MAGIC		; ""
		INCF	FSR
		INCF	EEADR		;   
		MOVF	EEADR,W
		SUBLW	H'20'		;  
		BTFSS	STATUS,Z
		GOTO	SVT0		;  
		BSF		INTCON,GIE	; 
		RETURN
;***********************************************************
;   EEPROM      **
;***********************************************************
SAVECON:		;  EEPROM  
		BCF		INTCON,GIE	; 
		MOVLW	H'20'		;      EEPROM
		MOVWF	EEADR		;    EEPROM
		MOVLW	H'4B'		;      RAM
		MOVWF	FSR			;   FSR
SVC0
		MOVF	INDF,W		; 
		MOVWF	EEDATA		;  EEDATA
		CALL	MAGIC		; ""
		INCF	FSR
		INCF	EEADR		;   
		MOVF	EEADR,W
		SUBLW	H'25'		;  
		BTFSS	STATUS,Z
		GOTO	SVC0		;  
		BSF		INTCON,GIE	; 
		RETURN
;****************************************************************
;""   MICROCHIP  					*
;****************************************************************
MAGIC
;****************************************************************
		BSF		STATUS,RP0	;  1					*
;****************************************************************
		BSF		EECON1,WREN	;""						*
		MOVLW	H'55'		;									*
		MOVWF	EECON2		;					*
		MOVLW	H'AA'		;									*
		MOVWF	EECON2		;									*
		BSF		EECON1,WR	;MICROCHIP							*
;****************************************************************
SVC1	btfsc   EECON1^80H,WR ;   	*
		GOTO	SVC1										;	*
;****************************************************************
		BCF		STATUS,RP0	;  0					*
		RETURN												;	*
;****************************************************************
		END
