#include<p16f84a.inc>
;CONFIG	_XT_OSC & _WDT_OFF & _PWRTE_ON
;  HT1611  Pic16 + Led
;
CBI		EQU	H'4F'	;  
CBY		EQU	H'4E'	;  
CTO		EQU	H'4D'	;   
COU		EQU	H'4C'	;  
VOL		EQU	H'4B'	;   
BAL		EQU	H'4A'	;   
BAS		EQU	H'49'	;   
TRE		EQU	H'48'	;   
F6		EQU	H'46';:  \  \  \   
					;\TIME OUT \  \ _\ 4/8BIT
R7		EQU	H'47'	;   
DIG1	EQU	H'0C'	;   "1"
DIG2	EQU	H'0D'	;   "2"
DIG3	EQU	H'0E'	;   "3"
DIG4	EQU	H'0F'	;   "4"
DIG5	EQU	H'10'	;   "5"
DIG6	EQU	H'11'	;   "6"
DIG7	EQU	H'12'	;   "7"
DIG8	EQU	H'13'	;   "8"
DIG9	EQU	H'14'	;   "9"
TOCH	EQU H'15'	; 
LED1	EQU	H'16'	;   1
LED2	EQU	H'17'	;   2
LED3	EQU	H'18'	;   3
LED4	EQU	H'19'	;   4
LED5	EQU	H'1A'	;   5
LED6	EQU	H'1B'	;   6
LED7	EQU	H'1C'	;   7
LED8	EQU	H'1D'	;   8
LED9	EQU	H'1E'	;   9
LPOZ	EQU	H'1F'	;    
LOUT	EQU	H'45'	;    
DPOZ	EQU	H'44'	;   
R5		EQU	H'43'	; 
R0		EQU	H'40'	; 
R1		EQU	H'41'	; 
;
		ORG H'0'
RESET	GOTO	START
		NOP
		NOP
		NOP
		ORG H'4'
;Interrupt  
		BCF		INTCON,GIE	;  
		BTFSC	INTCON,INTF	;     
		GOTO	CLKI		;   
		BTFSC	INTCON,T0IF	;    
		GOTO	TOF			;   
		RETFIE
START;	MOVLW	H'1'	;
		;ADDWF	COU,W
;GOTO	START
		BCF		STATUS,IRP
		BCF		STATUS,RP1
		BSF		STATUS,RP0	;  1
		MOVLW	B'00010001'	;A0, A4 -  ; A1, A2, A3 - 
		MOVWF	TRISA
		MOVLW	B'11111111'	; -  ; B0...B7
		MOVWF	TRISB
		MOVLW	B'11010000'	; ,    
		MOVWF	OPTION_REG	; ,     
							;     
		MOVLW	B'10110000'	;     
		MOVWF	INTCON		;,   
		BCF		STATUS,RP0	;  0
LOOP	GOTO	LOOP		;
		RETURN
EXIT	BCF		INTCON,T0IF	;   
		BCF		INTCON,INTF	;    
		RETFIE				;  
;   (TimeOut)
TOF		BCF		PORTA,H'1'	;  IRQ
		BSF		STATUS,RP0	;  1
		MOVLW	B'00000000'	; -  B0...B7
		MOVF	LOUT,W		; 
		BCF		STATUS,RP0	;  0

		MOVF	LPOZ,W		;  
		ADDLW	H'0C'		;    
		MOVWF	FSR			;    
		MOVF	INDF,W		;  
		ADDLW	H'20'		;    
		MOVWF	FSR			;    
		MOVF	INDF,W		;  
		MOVWF	R5			;  
		MOVF	LPOZ,W		;  
		ADDLW	H'16'		;    
		MOVWF	FSR			;    
		MOVF	R5,W		;  

		MOVWF	INDF		;   

		MOVWF	PORTB		;
		MOVF	VOL,W		;  
		SUBWF	COU,W		;   
		BTFSC	STATUS,Z	;  
		DECF	COU			;  1
		GOTO	EXIT		;  
;   INT0 (CLK)
CLKI	;BCF		PORTA,H'1'	;  IRQ
		BTFSS	PORTA,H'4'	;  
		GOTO	B4			;   1   (4BIT)
B8		BSF		F6,H'0'		; "0"  8  () .
		GOTO	BOUT		;  (1 - 8BIT)
B4		BCF		F6,H'0'		; "1"  4 
BOUT	BTFSC	PORTA,H'0'	;   
		GOTO	ONE			; "1"    
		BCF		R7,H'0'		; "0"    0
		GOTO	NULL		;  
ONE		BSF		R7,H'0'		;  0
NULL	RLF		R7			; 
		INCF	CBI			;  
		BTFSC	F6,H'0'		;   
		GOTO	BIT8		; "1"  8 
BIT4	MOVLW	H'4'		;
		GOTO	BITX		;4 
BIT8	MOVLW	H'8'		;  
BITX	SUBLW	CBI			;   
		BTFSC	STATUS,Z	;  (  )
		GOTO	ETOF		;  
BYTECOM	BSF		F6,H'1'		;  BYTE COMPLEET
		MOVF	CBY,W		;   
		ADDLW	H'0C'		;   
		MOVWF	FSR			;    
		MOVF	R7,W		;  
		MOVWF	INDF		;   
		CLRF	R7			;  
		CLRF	CBI			;  
		INCF	CBY			;    
		MOVLW	H'A'		;   
		SUBLW	CBY			;   
		BTFSC	STATUS,Z	; 
		GOTO	ETOF		;
		BSF		F6,H'2'		;  " "
		CLRF	CBY			;  
;   
ETOF	GOTO	EXIT		;  
		END
